using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Syncfusion.Grouping;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace DateGridGroupingTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            
            SetUpGrid();
            SetUpDataSource();
        }

        private void SetUpGrid()
        {
            this.gridGroupingControl1.TableDescriptor.Columns.Clear();

            GridColumnDescriptor gcd = new GridColumnDescriptor("Product");
            gcd.GroupByAppearance.GroupCaptionCell.Format = "#";
            gcd.GroupByAppearance.GroupCaptionCell.CellValueType = typeof(string);
            gcd.GroupByOptions.CaptionText = "{Category}";
            this.gridGroupingControl1.TableDescriptor.Columns.Add(gcd);

            gcd = new GridColumnDescriptor("Maturity");
            gcd.GroupByAppearance.GroupCaptionCell.Format = "dd-MMM-yyyy";
            gcd.GroupByAppearance.GroupCaptionCell.CellValueType = typeof(DateTime);
            gcd.GroupByOptions.CaptionText = "{Category}";
            gcd.GroupByOptions.ShowCaption = true;            
            this.gridGroupingControl1.TableDescriptor.Columns.Add(gcd);

            gcd = new GridColumnDescriptor("Data1");
            gcd.GroupByAppearance.GroupCaptionCell.Format = "0.00";
            gcd.GroupByAppearance.GroupCaptionCell.CellValueType = typeof(double);
            this.gridGroupingControl1.TableDescriptor.Columns.Add(gcd);

            gcd = new GridColumnDescriptor("Data2");
            gcd.GroupByAppearance.GroupCaptionCell.Format = "0.00";
            gcd.GroupByAppearance.GroupCaptionCell.CellValueType = typeof(double);
            this.gridGroupingControl1.TableDescriptor.Columns.Add(gcd);
            
            SortColumnDescriptor scd = new SortColumnDescriptor("Maturity");
            this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add(scd);

            scd = new SortColumnDescriptor("Product");
            this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add(scd);


        }

        private void SetUpDataSource()
        {
            DataTable dt = new DataTable();
            DataColumn col = new DataColumn("Product", typeof(string));
            dt.Columns.Add(col);
            col = new DataColumn("Maturity", typeof(DateTime));
            dt.Columns.Add(col);
            col = new DataColumn("Data1", typeof(double));
            dt.Columns.Add(col);
            col = new DataColumn("Data2", typeof(double));
            dt.Columns.Add(col);

            DataRow row = dt.NewRow();
            row["Product"] = "CDS";
            row["Maturity"] = new DateTime(2008, 6, 20);
            row["Data1"] = 10;
            row["Data2"] = 20;
            dt.Rows.Add(row);

            row = dt.NewRow();
            row["Product"] = "CDS";
            row["Maturity"] = new DateTime(2008, 9, 20);
            row["Data1"] = 10;
            row["Data2"] = 20;
            dt.Rows.Add(row);

            row = dt.NewRow();
            row["Product"] = "CDS";
            row["Maturity"] = new DateTime(2008, 12, 20);
            row["Data1"] = 10;
            row["Data2"] = 20;
            dt.Rows.Add(row);

            row = dt.NewRow();
            row["Product"] = "Bond";
            row["Maturity"] = new DateTime(2008, 6, 20);
            row["Data1"] = 10;
            row["Data2"] = 20;
            dt.Rows.Add(row);

            row = dt.NewRow();
            row["Product"] = "Bond";
            row["Maturity"] = new DateTime(2008, 9, 20);
            row["Data1"] = 10;
            row["Data2"] = 20;
            dt.Rows.Add(row);

            row = dt.NewRow();
            row["Product"] = "Bond";
            row["Maturity"] = new DateTime(2008, 12, 20);
            row["Data1"] = 10;
            row["Data2"] = 20;
            dt.Rows.Add(row);

            row = dt.NewRow();
            row["Product"] = "Loan";
            row["Maturity"] = new DateTime(2008, 6, 20);
            row["Data1"] = 10;
            row["Data2"] = 20;
            dt.Rows.Add(row);

            row = dt.NewRow();
            row["Product"] = "Loan";
            row["Maturity"] = new DateTime(2008, 9, 20);
            row["Data1"] = 10;
            row["Data2"] = 20;
            dt.Rows.Add(row);

            row = dt.NewRow();
            row["Product"] = "Loan";
            row["Maturity"] = new DateTime(2008, 12, 20);
            row["Data1"] = 10;
            row["Data2"] = 20;
            dt.Rows.Add(row);

            this.gridGroupingControl1.DataSource = dt;


        }


    }
}